#include <linux/slab.h>
#include <linux/fs.h>
#include "hfcopvx.h"


void OPVOS_MutexInit(OPVOS_mutex_t *mutex){
		if ( (*mutex =kmalloc(sizeof(struct semaphore), GFP_KERNEL)) != NULL )
      	sema_init((*mutex), 1);	
}

void OPVOS_MutexLock(OPVOS_mutex_t *mutex){
		down(*mutex);
}

int OPVOS_MutexLockInterruptible(OPVOS_mutex_t *mutex)
{
		return down_interruptible(*mutex);	
}

void OPVOS_MutexUnlock(OPVOS_mutex_t *mutex) 
{ 
		up(*mutex);
}

void OPVOS_MutexDelete(OPVOS_mutex_t *mutex){
	  kfree(*mutex); 
	  *mutex = 0;
}

